LayOut C API

- Main Page
- Related Pages
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Data Fields

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Data Structures
Here are the data structures with brief descriptions:

LOAngularDimensionRef | References an angular dimension entity. An angular dimension is composed of the following sub-entities:
LOApplicationRef | Encapsulates a LayOut application
LOAutoTextDefinitionListRef | References an ordered, indexable list of LOAutoTextDefinitionRef objects
LOAutoTextDefinitionRef | References an auto-text definition
LOAxisAlignedRect2D | Represents a 2D rectangle that is aligned with the X and Y axis of the coordinate system
LOConnectionPointRef | References a connection point. A connection point defines a target point to which a label or dimension can connect
LODictionaryRef | References a dictionary. A dictionary maps string keys to LOTypedValueRef values
LODocumentRef | References a LayOut document
LOEllipseRef | References a simple elliptical shape entity
LOEntityIteratorRef | References an iterator for LOEntityRef objects
LOEntityListRef | References an ordered, indexable list of LOEntityRef objects
LOEntityRef | An entity is an object shown on a page of a LayOut document
LOFormattedTextRef | References a formatted text entity
LOGridRef | References a document's grid settings
LOGroupRef | References a group entity. A group is a special type of entity that does not belong to a layer and contains other entities as children. A group's children may include other groups, allowing for a hierarchical tree structure of entities. A group must contain at least one child and will be automatically collapsed if an operation is performed that results in the group being empty
LOImageRef | References a raster image entity
LOImageRepRef | References the bitmap representation for a raster image
LOLabelRef | References a label entity. A label consists of the label text (formatted text entity) and the label leader (path entity). A label may be connected to another entity via a LOConnectionPointRef object
LOLayerInstanceRef | References a layer instance. A layer instance provides access to the entities that are drawn on a given layer, as well as the draw order of those entities. Groups are not included in the list of entities associated with a layer instance, since the group hierarchy has no effect on entity draw order. Each page has one layer instance for each layer in the document. Non-shared layer instances are unique per page, while shared layer instances are shared across all pages of the document
LOLayerListRef | References an ordered, indexable list of LOLayerRef objects
LOLayerRef | References a layer definition. A layer definition specifies the document-wide information about a layer. To access the entities on a layer for a given page, use LOLayerInstanceRef
LOLinearDimensionRef | References a linear dimension entity. A linear dimension is composed of the following sub-entities:
LOOrientedRect2D | Represents a 2D rectangle that might be rotated. Each corner of the rectangle is represented by a separate 2D point
LOPageInfoRef | References the page information for a document. This specifies the physical page dimensions and other page-related settings for a document
LOPageListRef | References an ordered, indexable list of LOPageRef objects
LOPageRef | References a single page in a document
LOPathRef | References a path entity. A path entity represents a continuous, multi-segment polyline or Bezier curve
LORect2D | Represents a 2D rectangle
LORectangleRef | References a simple rectangular shape entity
LOReferenceEntityRef | References an entity containing the contents of an imported file
LOSelectionSetRef | References a selection set. A selection set tracks the current selection in a LODocumentRef
LOSketchUpModelRef | References a SketchUp model viewport entity
LOStyleRef | References a collection of style attributes that determine the visual appearance of entities. Style attributes are those attributes which the user can manipulate in LayOut's inspector windows. For example, shape style attributes that define stroke and fill, or text style attributes that define the font for formatted text. The document maintains a default style for various types of entities, and it is possible to apply the style of one entity to another. LOStyleRef objects are transient and do not belong to a document
LOTableRef | References a table. A table is a series of rows and columns that holds data
LOTransformMatrix2D | 2x3 matrix for representing 2D transforms on LayOut entities. The matrix is stored in column-major format:
LOTypedValueRef | References a variant object used to represent a value of an arbitrary type
SUAxisAlignedRect2D | Represents a 2D rectangle that is aligned with the X and Y axis of the coordinate system. The coordinates of the points of the rectangle are in inches
SUBeginFrameInfo | Information about the frame camera and viewport that is passed to SUOverlayCreateInfo::begin_frame
SUBoundingBox3D | Represents a 3D axis-aligned bounding box represented by the extreme diagonal corner points with minimum and maximum x,y,z coordinates. The coordinates of the points are in inches
SUColor | Stores a RGBA color with 8 bit channels
SUDrawFrameMemoryBuffer | Memory buffer (for color and depth) info used in SUOverlayDrawFrameInfo
SULengthFormatterRef | References a length formatter object. Length formatters are used to generate formatted strings (optionally with units) from length, area, and volume values. Additionally length formatters can be used to translate a formatted length/area/volume string into a value. Accessors and setters are exposed for some of the key formatting properties, facilitating customization of the formater. In cases when users want the formatter to reflect the properties of a model, SUModelGetLengthFormatter should be used to more efficiently extract/copy the relevant properties from the model to the formatter
SUOverlayCreateInfo | Arguments for creating an overlay object
SUOverlayDrawFrameInfo | Data that SketchUp will use the to blend the given color/depth buffer onto SketchUp rendering
SUOverlayRef | Manages a Overlay object, which is used to blend external images on top of SketchUp rendering
SUPlane3D | Represents a 3D plane by the parameters a, b, c, d. For any point on the plane, ax + by + cz + d = 0. The coeficients are normalized so that a*a + b*b + c*c = 1
SUPoint2D | Represents a point in 2-dimensional space. The coordinates are represented in inches
SUPoint3D | Represents a point in 3-dimensional space. The coordinates are represented in inches
SURay3D | Represents a 3D ray defined by a point and normal vector. The coordinates of the point are represented in inches
SUStringRef | Stores a Unicode string for use as output string parameters in the API
SUTransformation | Represents a 3D (4x4) geometric transformation matrix
SUTransformation2D | Represents a 2D (2x3) affine transformation matrix. The matrix is stored in column-major format:
SUVector2D | Represents a vector in 2-dimensional space. The magnitudes are represented in inches
SUVector3D | Represents a vector in 3-dimensional space. The magnitudes are represented in inches